;;;; defstruct.scm

(define-macro defstruct
  (lambda (s . ff0)
    (let ((s-s (symbol->string s)) (n (length ff0)))
      (let* ((n+1 (+ n 1))
             (vv (make-vector n+1)))
        (let loop ((i 1) (ff ff0))
          (if (<= i n)
            (let ((f (car ff)))
              (vector-set! vv i 
                (if (pair? f) (cadr f) '(void)))
              (loop (+ i 1) (cdr ff)))))
        (let* ((ff (map (lambda (f) (if (pair? f) (car f) f)) ff0))
	       (ffk (map (lambda (f) (string->keyword (symbol->string f))) ff)) )
          `(begin
             (define (,(string->symbol (string-append "make-" s-s)) #!key ,@ff0)
	       (##sys#make-structure ',s ,@ff))
             ,@(let loop ((i 1) (procs '()))
                 (if (>= i n+1) procs
                     (loop (+ i 1)
                           (let ((f (symbol->string
                                     (list-ref ff (- i 1)))))
                             (cons
                              (let ((getter (string->symbol (string-append s-s "-" f))))
				`(define ,getter
				   (lambda (x) 
				     (##sys#check-structure x ',s ',getter)
				     (##sys#slot x ,i))) )
                              (cons
                               (let ((setter (string->symbol (string-append s-s "-" f "-set!"))))
				 `(define ,setter
				    (lambda (x v) 
				      (##sys#check-structure x ',s ',setter)
				      (##sys#setslot x ,i v))) )
                               procs))))))
             (define ,(string->symbol (string-append s-s "?"))
               (lambda (x) (##sys#structure? x ',s)) ) ) ) ) ) ) )
